%if 0%{?el5}
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

# get selinux policy version
%{!?_selinux_policy_version: %global _selinux_policy_version %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp 2>/dev/null || echo 0.0.0)}

%global _hardened_build 1

# Use systemd files on RHEL 7 and above.
# Note: We don't install unit files for the services yet. For now,
# the _with_systemd variable only implies that we'll install
# /etc/tmpfiles.d/ceph.conf in order to set up the socket directory in
# /var/run/ceph.
%if 0%{?fedora} || 0%{?rhel} >= 7
  %global _with_systemd 1
%endif

# LTTng-UST enabled on Fedora, RHEL 6, and SLES 12
%global _with_lttng 1

#################################################################################
# common
#################################################################################
Name:		ceph
Version:	0.94.9
Release:	9%{?dist}
Epoch:		1
Summary:	User space components of the Ceph file system
License:	GPLv2
Group:		System Environment/Base
URL:		http://ceph.com/
Source0:	http://download.ceph.com/tarballs/%{name}-%{version}.tar.gz
# For Source1, see http://tracker.ceph.com/issues/11383
Source1:	https://raw.githubusercontent.com/ceph/ceph/71a5090bca049a43e30a7f0cf99141950ef9c5dd/systemd/ceph.tmpfiles.d

Source3:	ceph.te
Source4:	ceph.fc
Source5:	ceph.if

Source6:	ceph_selinux.8

Patch0001: 0001-mon-return-size_t-from-MonitorDBStore-Transaction-si.patch
Patch0002: 0002-init-ceph.in-skip-ceph-disk-if-it-is-not-present.patch
Patch0003: 0003-Fix-selinux-context-after-intitial-OSD-mount.patch
Patch0004: 0004-ceph-disk-only-call-restorecon-when-available.patch
Patch0005: 0005-ceph.in-improve-the-error-message.patch
Patch0006: 0006-13207-Rados-Gateway-Anonymous-user-is-able-to-read-b.patch
Patch0007: 0007-rgw-Let-the-default-quota-settings-take-effect-durin.patch
Patch0008: 0008-rgw-Do-not-bother-to-check-against-conf-values-durin.patch
Patch0009: 0009-rgw_admin-improve-the-orphans-find-help.patch
Patch0010: 0010-radosgw-admin-add-orphan-stale-secs-to-help.patch
Patch0011: 0011-man-add-orphan-options-to-radosgw-admin.8.patch
Patch0012: 0012-ceph-objectstore-tool-add-a-way-to-split-filestore-d.patch
Patch0013: 0013-cls-rgw-utilities-to-support-raw-bucket-index-operat.patch
Patch0014: 0014-rgw-use-bucket_info.bucket_id-instead-of-marker-wher.patch
Patch0015: 0015-rgw-utilities-to-support-raw-bucket-index-operations.patch
Patch0016: 0016-rgw-rgw_obj-encoding-fixes.patch
Patch0017: 0017-rgw_admin-bucket-rehsrading-initial-work.patch
Patch0018: 0018-cls-rgw-fix-bi_list-objclass-command.patch
Patch0019: 0019-radosgw-admin-bucket-reshard-needs-num-shards-to-be-.patch
Patch0020: 0020-rgw-rgw_link_bucket-use-correct-bucket-structure-for.patch
Patch0021: 0021-rgw_admin-reshard-also-links-to-new-bucket-instance.patch
Patch0022: 0022-cls-rgw-add-bucket_update_stats-method.patch
Patch0023: 0023-rgw-bucket-reshard-updates-stats.patch
Patch0024: 0024-rgw_admin-use-aio-operations-for-bucket-resharding.patch
Patch0025: 0025-rgw_admin-fix-bi-list-command.patch
Patch0026: 0026-rgw-limit-bucket-reshard-num-shards-to-max-possible.patch
Patch0027: 0027-rgw_admin-better-bucket-reshard-logging.patch
Patch0028: 0028-rgw_admin-require-yes-i-really-mean-it-for-bucket-re.patch
Patch0029: 0029-cls-rgw-bi_list-fix-is_truncated-returned-param.patch
Patch0030: 0030-rgw-bucket-resharding-adjust-logging.patch
Patch0031: 0031-rgw_admin-add-bi-purge-command.patch
Patch0032: 0032-Don-t-loop-forever-when-reading-data-from-0-sized-se.patch
Patch0033: 0033-rgw-handle-empty-POST-condition.patch
Patch0034: 0034-Revert-rgw-rgw_obj-encoding-fixes.patch
Patch0035: 0035-rgw-use-hammer-rgw_obj_key-api.patch
Patch0036: 0036-rgw-do-not-abort-when-accept-a-CORS-request-with-sho.patch

Requires:	librbd1 = %{epoch}:%{version}-%{release}
Requires:	librados2 = %{epoch}:%{version}-%{release}
Requires:	ceph-common = %{epoch}:%{version}-%{release}
Requires:	python-rados = %{epoch}:%{version}-%{release}
Requires:	python-rbd = %{epoch}:%{version}-%{release}
Requires:	python
Requires:	python-argparse
Requires:	python-requests
%if ! ( 0%{?rhel} && 0%{?rhel} <= 6 )
Requires:	xfsprogs
%endif
Requires:	cryptsetup
Requires:	parted
Requires:	util-linux
%ifnarch s390 s390x
Requires:	hdparm
%endif
# For initscript
Requires(post):	binutils
BuildRequires:	checkpolicy
BuildRequires:	selinux-policy-devel
BuildRequires:	/usr/share/selinux/devel/policyhelp
BuildRequires:	make
BuildRequires:	gcc-c++
BuildRequires:	libtool
BuildRequires:	boost-devel
BuildRequires:	bzip2-devel
BuildRequires:	libedit-devel
BuildRequires:	perl
BuildRequires:	gdbm
BuildRequires:	pkgconfig
BuildRequires:	python
BuildRequires:	python-nose
BuildRequires:	python-argparse
BuildRequires:	libaio-devel
BuildRequires:	libcurl-devel
BuildRequires:	libxml2-devel
BuildRequires:	libuuid-devel
BuildRequires:	libblkid-devel >= 2.17
BuildRequires:	libudev-devel
BuildRequires:	leveldb-devel > 1.2
%if ! ( 0%{?rhel} && 0%{?rhel} <= 6 )
BuildRequires:	xfsprogs-devel
%endif
BuildRequires:	yasm
BuildRequires:	snappy-devel

#################################################################################
# specific
#################################################################################

Requires:	gdisk
BuildRequires:	nss-devel
BuildRequires:	keyutils-libs-devel
BuildRequires:	libatomic_ops-devel
Requires:	gdisk
Requires(post):	chkconfig
Requires(preun):chkconfig
Requires(preun):initscripts
%ifnarch ppc ppc64 s390 s390x
BuildRequires:	gperftools-devel
%endif

%description
Ceph is a massively scalable, open-source, distributed
storage system that runs on commodity hardware and delivers object,
block and file system storage.


#################################################################################
# packages
#################################################################################
%package -n ceph-common
Summary:	Ceph Common
Group:		System Environment/Base
Requires:	librbd1 = %{epoch}:%{version}-%{release}
Requires:	librados2 = %{epoch}:%{version}-%{release}
Requires:	python-rados = %{epoch}:%{version}-%{release}
Requires:	python-rbd = %{epoch}:%{version}-%{release}
Requires:	python-requests
%description -n ceph-common
Common utilities to mount and interact with a ceph storage cluster.

%package mon
Summary:	Ceph Monitor Software
Group:		System Environment/Base
Requires:	ceph = %{epoch}:%{version}-%{release}
# For ceph-rest-api
Requires:	python-flask
%description mon
ceph-mon is the cluster monitor daemon for the Ceph distributed file
system. One or more instances of ceph-mon form a Paxos part-time
parliament cluster that provides extremely reliable and durable storage
of cluster membership, configuration, and state.

%package radosgw
Summary:	Rados REST gateway
Group:		System Environment/Base
Requires:	ceph-common = %{epoch}:%{version}-%{release}
Requires:	librados2 = %{epoch}:%{version}-%{release}
BuildRequires:	expat-devel
BuildRequires:	fcgi-devel
%description radosgw
radosgw is an S3 HTTP REST gateway for the RADOS object store. It is
implemented as a FastCGI module using libfcgi, and can be used in
conjunction with any FastCGI capable web server.

%package osd
Summary:	Ceph Object Storage Daemon
Group:		System Environment/Base
Requires:	ceph = %{epoch}:%{version}-%{release}
%description osd
ceph-osd is the object storage daemon for the Ceph distributed file
system.  It is responsible for storing objects on a local file system
and providing access to them over the network.

%package -n librados2
Summary:	RADOS distributed object store client library
Group:		System Environment/Libraries
License:	LGPL-2.0
%if 0%{?rhel} || 0%{?centos} || 0%{?fedora}
Obsoletes:	ceph-libs < 1:0.80.5
%endif
%description -n librados2
RADOS is a reliable, autonomic distributed object storage cluster
developed as part of the Ceph distributed storage system. This is a
shared library allowing applications to access the distributed object
store using a simple file-like interface.

%package -n librados2-devel
Summary:	RADOS headers
Group:		Development/Libraries
License:	LGPL-2.0
Requires:	librados2 = %{epoch}:%{version}-%{release}
Obsoletes:	ceph-devel
%description -n librados2-devel
This package contains libraries and headers needed to develop programs
that use RADOS object store.

%package -n python-rados
Summary:	Python libraries for the RADOS object store
Group:		System Environment/Libraries
License:	LGPL-2.0
Requires:	librados2 = %{epoch}:%{version}-%{release}
Obsoletes:	python-ceph
%description -n python-rados
This package contains Python libraries for interacting with Cephs RADOS
object store.

%package -n libradosstriper1
Summary:	RADOS striping interface
Group:		System Environment/Libraries
License:	LGPL-2.0
Requires:	librados2 = %{epoch}:%{version}-%{release}
%description -n libradosstriper1
Striping interface built on top of the rados library, allowing
to stripe bigger objects onto several standard rados objects using
an interface very similar to the rados one.

%package -n libradosstriper1-devel
Summary:	RADOS striping interface headers
Group:		Development/Libraries
License:	LGPL-2.0
Requires:	libradosstriper1 = %{epoch}:%{version}-%{release}
Requires:	librados2-devel = %{epoch}:%{version}-%{release}
Obsoletes:	ceph-devel < %{epoch}:%{version}-%{release}
%description -n libradosstriper1-devel
This package contains libraries and headers needed to develop programs
that use RADOS striping interface.

%package -n librbd1
Summary:	RADOS block device client library
Group:		System Environment/Libraries
License:	LGPL-2.0
Requires:	librados2 = %{epoch}:%{version}-%{release}
Obsoletes:	ceph-libs
%description -n librbd1
RBD is a block device striped across multiple distributed objects in
RADOS, a reliable, autonomic distributed object storage cluster
developed as part of the Ceph distributed storage system. This is a
shared library allowing applications to manage these block devices.

%package -n librbd1-devel
Summary:	RADOS block device headers
Group:		Development/Libraries
License:	LGPL-2.0
Requires:	librbd1 = %{epoch}:%{version}-%{release}
Requires:	librados2-devel = %{epoch}:%{version}-%{release}
Obsoletes:	ceph-devel
%description -n librbd1-devel
This package contains libraries and headers needed to develop programs
that use RADOS block device.

%package -n python-rbd
Summary:	Python libraries for the RADOS block device
Group:		System Environment/Libraries
License:	LGPL-2.0
Requires:	librbd1 = %{epoch}:%{version}-%{release}
Requires:	python-rados = %{epoch}:%{version}-%{release}
Obsoletes:	python-ceph
%description -n python-rbd
This package contains Python libraries for interacting with Cephs RADOS
block device.

%package -n libcephfs1
Summary:	Ceph distributed file system client library
Group:		System Environment/Libraries
License:	LGPL-2.0
Obsoletes:	ceph-libs < %{epoch}:%{version}-%{release}
Obsoletes:	ceph-libcephfs < %{epoch}:%{version}-%{release}
%description -n libcephfs1
Ceph is a distributed network file system designed to provide excellent
performance, reliability, and scalability. This is a shared library
allowing applications to access a Ceph distributed file system via a
POSIX-like interface.

%package -n libcephfs1-devel
Summary:	Ceph distributed file system headers
Group:		Development/Libraries
License:	LGPL-2.0
Requires:	libcephfs1 = %{epoch}:%{version}-%{release}
Requires:	librados2-devel = %{epoch}:%{version}-%{release}
Obsoletes:	ceph-devel
%description -n libcephfs1-devel
This package contains libraries and headers needed to develop programs
that use Cephs distributed file system.

%package -n python-cephfs
Summary:	Python libraries for Ceph distributed file system
Group:		System Environment/Libraries
License:	LGPL-2.0
Requires:	libcephfs1 = %{epoch}:%{version}-%{release}
Requires:	python-rados = %{epoch}:%{version}-%{release}
Obsoletes:	python-ceph
%description -n python-cephfs
This package contains Python libraries for interacting with Cephs distributed
file system.

%package -n ceph-test
Summary:	Ceph benchmarks and test tools
Group:		System Environment/Libraries
License:	LGPL-2.0
Requires:	ceph-common
%if 0%{?_with_lttng}
BuildRequires:	lttng-ust-devel
BuildRequires:	libbabeltrace-devel
%endif
%description -n ceph-test
This package contains Ceph benchmarks and test tools.

%package selinux
Summary:	SELinux support for Ceph MON, OSD and MDS
Group:		System Environment/Base
Requires:	policycoreutils, libselinux-utils
Requires(post): selinux-policy-base >= %{_selinux_policy_version}, policycoreutils, gawk
Requires(postun): policycoreutils
%description selinux
This package contains SELinux support for Ceph MON, OSD and MDS. The package
also performs file-system relabelling which can take a long time on heavily
populated file-systems.

#################################################################################
# common
#################################################################################
%prep
%setup -q

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1

# Copy SELinux files
mkdir -p selinux
cp %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6} selinux/

# Rewrite .git_version file.
# `rdopkg update-patches` will automatically update this macro:
%global commit b83334e01379f267fb2f9ce729d74a0a8fa1e92c
# and then the macro gets written into .git_version:
echo %{commit} > src/.git_version
echo v%{version}-%{release} >> src/.git_version

%build
# Build SELinux policy
pushd selinux
make -j1 -f /usr/share/selinux/devel/Makefile ceph.pp
gzip ceph_selinux.8
popd

# Regular build
./autogen.sh

%if ( 0%{?rhel} && 0%{?rhel} <= 6)
MY_CONF_OPT="--without-libxfs $CEPH_EXTRA_CONFIGURE_ARGS"
%else
MY_CONF_OPT="$CEPH_EXTRA_CONFIGURE_ARGS"
%endif

# No need to build fuse, rest-bench, and ocf pkgs so far
# Use nss instead of cryptopp library
MY_CONF_OPT="$MY_CONF_OPT --with-tcmalloc --with-debug --with-radosgw --without-rest-bench --without-fuse --without-ocf --without-cryptopp --with-nss --without-cephfs --without-mds"

export RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/i386/i486/'`

%{configure}	--prefix=/usr \
		--localstatedir=/var \
		--sysconfdir=/etc \
		--docdir=%{_docdir}/ceph \
		$MY_CONF_OPT \
		CFLAGS="$RPM_OPT_FLAGS $EXTRA_CFLAGS" \
		CXXFLAGS="$RPM_OPT_FLAGS $EXTRA_CFLAGS" \
		LDFLAGS="$EXTRA_LDFLAGS"

make %{_smp_mflags}

%install
# Install SELinux policy
install -d $RPM_BUILD_ROOT%{_datadir}/selinux/packages
install -m 644 selinux/ceph.pp $RPM_BUILD_ROOT%{_datadir}/selinux/packages/ceph.pp
install -d $RPM_BUILD_ROOT%{_datadir}/selinux/devel/include/contrib
install -m 644 selinux/ceph.if $RPM_BUILD_ROOT%{_datadir}/selinux/devel/include/contrib/ceph.if
install -m 644 -D selinux/ceph_selinux.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/ceph_selinux.8.gz

# Regular install
make DESTDIR=$RPM_BUILD_ROOT install
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type f -name "*.a" -exec rm -f {} ';'
install -D src/init-ceph $RPM_BUILD_ROOT%{_initrddir}/ceph
install -D src/init-radosgw $RPM_BUILD_ROOT%{_initrddir}/ceph-radosgw
install -D src/init-rbdmap $RPM_BUILD_ROOT%{_initrddir}/rbdmap
install -D src/rbdmap $RPM_BUILD_ROOT%{_sysconfdir}/ceph/rbdmap
%if 0%{?_with_systemd}
  install -m 0644 -D %{SOURCE1} $RPM_BUILD_ROOT%{_tmpfilesdir}/%{name}.conf
%endif
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
ln -sf ../../etc/init.d/ceph %{buildroot}/%{_sbindir}/rcceph
ln -sf ../../etc/init.d/ceph-radosgw %{buildroot}/%{_sbindir}/rcceph-radosgw
install -m 0644 -D src/logrotate.conf $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/ceph
install -m 0644 -D src/rgw/logrotate.conf $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/radosgw
chmod 0644 $RPM_BUILD_ROOT%{_docdir}/ceph/sample.ceph.conf
chmod 0644 $RPM_BUILD_ROOT%{_docdir}/ceph/sample.fetch_config

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
echo "TCMALLOC_MAX_TOTAL_THREAD_CACHE_BYTES=128MB" > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ceph

# udev rules
%if 0%{?rhel} >= 7 || 0%{?fedora}
install -m 0644 -D udev/50-rbd.rules $RPM_BUILD_ROOT/usr/lib/udev/rules.d/50-rbd.rules
install -m 0644 -D udev/60-ceph-partuuid-workaround.rules $RPM_BUILD_ROOT/usr/lib/udev/rules.d/60-ceph-partuuid-workaround.rules
%else
install -m 0644 -D udev/50-rbd.rules $RPM_BUILD_ROOT/lib/udev/rules.d/50-rbd.rules
install -m 0644 -D udev/60-ceph-partuuid-workaround.rules $RPM_BUILD_ROOT/lib/udev/rules.d/60-ceph-partuuid-workaround.rules
%endif

%if (0%{?rhel} && 0%{?rhel} < 7)
install -m 0644 -D udev/95-ceph-osd-alt.rules $RPM_BUILD_ROOT/lib/udev/rules.d/95-ceph-osd.rules
%else
install -m 0644 -D udev/95-ceph-osd.rules $RPM_BUILD_ROOT/lib/udev/rules.d/95-ceph-osd.rules
%endif

%if 0%{?rhel} >= 7 || 0%{?fedora}
mv $RPM_BUILD_ROOT/lib/udev/rules.d/95-ceph-osd.rules $RPM_BUILD_ROOT/usr/lib/udev/rules.d/95-ceph-osd.rules
mv $RPM_BUILD_ROOT/sbin/mount.ceph $RPM_BUILD_ROOT/usr/sbin/mount.ceph
%endif

#set up placeholder directories
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ceph
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run/ceph
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/ceph
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/ceph/tmp
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/ceph/mon
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/ceph/osd
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/ceph/bootstrap-osd
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/radosgw

# Remove files that should not be present in the RHCEPH package.
rm $RPM_BUILD_ROOT/sbin/mount.fuse.ceph
rm $RPM_BUILD_ROOT%{_bindir}/ceph_test_rados_striper_api_aio
rm $RPM_BUILD_ROOT%{_bindir}/ceph_test_rados_striper_api_io
rm $RPM_BUILD_ROOT%{_bindir}/ceph_test_rados_striper_api_striping

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add ceph
mkdir -p %{_localstatedir}/run/ceph/

%preun
if [ $1 = 0 ] ; then
    /sbin/service ceph stop >/dev/null 2>&1
    /sbin/chkconfig --del ceph
fi

%postun
/sbin/ldconfig


#################################################################################
# files
#################################################################################
%files
%defattr(-,root,root,-)
%docdir %{_docdir}
%dir %{_docdir}/ceph
%{_docdir}/ceph/sample.ceph.conf
%{_docdir}/ceph/sample.fetch_config
%{_bindir}/crushtool
%{_bindir}/monmaptool
%{_bindir}/osdmaptool
%{_bindir}/ceph-run
%{_bindir}/librados-config
%{_bindir}/ceph-debugpack
%{_bindir}/ceph-coverage
%{_initrddir}/ceph
%if 0%{?_with_systemd}
%{_tmpfilesdir}/%{name}.conf
%endif
%{_sbindir}/ceph-disk-udev
%{_sbindir}/ceph-create-keys
%{_sbindir}/rcceph
%if 0%{?rhel} >= 7 || 0%{?fedora}
%{_sbindir}/mount.ceph
%else
/sbin/mount.ceph
%endif
%dir %{_libdir}/ceph
%{_libdir}/ceph/ceph_common.sh
%{_libexecdir}/ceph/ceph-osd-prestart.sh
%dir %{_libdir}/ceph/erasure-code
%{_libdir}/ceph/erasure-code/libec_*.so*
%if 0%{?_with_lttng}
%{_libdir}/libos_tp.so*
%{_libdir}/libosd_tp.so*
%endif
%config %{_sysconfdir}/bash_completion.d/ceph
%config(noreplace) %{_sysconfdir}/logrotate.d/ceph
%config(noreplace) %{_sysconfdir}/sysconfig/ceph
%{_mandir}/man8/ceph-create-keys.8*
%{_mandir}/man8/ceph-deploy.8*
%{_mandir}/man8/ceph-disk.8*
%{_mandir}/man8/ceph-run.8*
%{_mandir}/man8/ceph-rest-api.8*
%{_mandir}/man8/crushtool.8*
%{_mandir}/man8/osdmaptool.8*
%{_mandir}/man8/monmaptool.8*
%{_mandir}/man8/mount.ceph.8*
%{_mandir}/man8/ceph-debugpack.8*
%{_mandir}/man8/librados-config.8.gz
#set up placeholder directories
%dir %{_localstatedir}/lib/ceph/
%dir %{_localstatedir}/lib/ceph/tmp
%dir %{_localstatedir}/lib/ceph/bootstrap-osd
%ghost %dir %{_localstatedir}/run/ceph/

#################################################################################
%files common
%defattr(-,root,root,-)
%{_bindir}/ceph
%{_bindir}/ceph-authtool
%{_bindir}/ceph-conf
%{_bindir}/ceph-rbdnamer
%{_bindir}/ceph-syn
%{_bindir}/ceph-crush-location
%{_bindir}/rados
%{_bindir}/rbd
%{_bindir}/rbd-replay
%{_bindir}/rbd-replay-many
%if 0%{?_with_lttng}
%{_bindir}/rbd-replay-prep
%endif
%{_bindir}/ceph-post-file
%{_bindir}/ceph-brag
%{_bindir}/ceph-dencoder
%{_mandir}/man8/ceph.8*
%{_mandir}/man8/ceph-authtool.8*
%{_mandir}/man8/ceph-conf.8*
%{_mandir}/man8/ceph-rbdnamer.8*
%{_mandir}/man8/ceph-syn.8*
%{_mandir}/man8/ceph-post-file.8*
%{_mandir}/man8/rados.8*
%{_mandir}/man8/rbd.8*
%{_mandir}/man8/rbd-replay.8*
%{_mandir}/man8/rbd-replay-many.8*
%{_mandir}/man8/rbd-replay-prep.8*
%{_mandir}/man8/ceph-dencoder.8*
%{_datadir}/ceph/known_hosts_drop.ceph.com
%{_datadir}/ceph/id_dsa_drop.ceph.com
%{_datadir}/ceph/id_dsa_drop.ceph.com.pub
%dir %{_sysconfdir}/ceph/
%dir %{_localstatedir}/log/ceph/
%config %{_sysconfdir}/bash_completion.d/rados
%config %{_sysconfdir}/bash_completion.d/rbd
%config(noreplace) %{_sysconfdir}/ceph/rbdmap
%{_initrddir}/rbdmap
%{python_sitelib}/ceph_argparse.py*
%if 0%{?rhel} >= 7 || 0%{?fedora}
/usr/lib/udev/rules.d/50-rbd.rules
%else
/lib/udev/rules.d/50-rbd.rules
%endif

%postun common
# Package removal cleanup
if [ "$1" -eq "0" ] ; then
    rm -rf /var/log/ceph
    rm -rf /etc/ceph
fi

%files mon
%{_bindir}/ceph-mon
%{_bindir}/ceph-rest-api
%{_mandir}/man8/ceph-mon.8*
%dir %{_localstatedir}/lib/ceph/mon
%{python_sitelib}/ceph_rest_api.py*

%files osd
%{_bindir}/ceph-clsinfo
%{_bindir}/ceph-objectstore-tool
%{_bindir}/ceph-osd
%{_sbindir}/ceph-disk
%{_sbindir}/ceph-disk-activate
%{_sbindir}/ceph-disk-prepare
%dir %{_libdir}/rados-classes
%{_libdir}/rados-classes/libcls_rbd.so*
%{_libdir}/rados-classes/libcls_hello.so*
%{_libdir}/rados-classes/libcls_rgw.so*
%{_libdir}/rados-classes/libcls_lock.so*
%{_libdir}/rados-classes/libcls_kvs.so*
%{_libdir}/rados-classes/libcls_refcount.so*
%{_libdir}/rados-classes/libcls_log.so*
%{_libdir}/rados-classes/libcls_replica_log.so*
%{_libdir}/rados-classes/libcls_statelog.so*
%{_libdir}/rados-classes/libcls_user.so*
%{_libdir}/rados-classes/libcls_version.so*
%if 0%{?rhel} >= 7 || 0%{?fedora}
/usr/lib/udev/rules.d/60-ceph-partuuid-workaround.rules
/usr/lib/udev/rules.d/95-ceph-osd.rules
%else
/lib/udev/rules.d/60-ceph-partuuid-workaround.rules
/lib/udev/rules.d/95-ceph-osd.rules
%endif
%{_mandir}/man8/ceph-clsinfo.8*
%{_mandir}/man8/ceph-osd.8*
%dir %{_localstatedir}/lib/ceph/osd

#################################################################################
%files -n librados2
%defattr(-,root,root,-)
%{_libdir}/librados.so.*
%if 0%{?_with_lttng}
%{_libdir}/librados_tp.so.*
%endif


%post -n librados2
/sbin/ldconfig

%postun -n librados2
/sbin/ldconfig

#################################################################################
%files -n librados2-devel
%defattr(-,root,root,-)
%dir %{_includedir}/rados
%{_includedir}/rados/librados.h
%{_includedir}/rados/librados.hpp
%{_includedir}/rados/buffer.h
%{_includedir}/rados/page.h
%{_includedir}/rados/crc32c.h
%{_includedir}/rados/rados_types.h
%{_includedir}/rados/rados_types.hpp
%{_includedir}/rados/memory.h
%{_libdir}/librados.so
%if 0%{?_with_lttng}
%{_libdir}/librados_tp.so
%endif

#################################################################################
%files -n libradosstriper1
%defattr(-,root,root,-)
%{_libdir}/libradosstriper.so.*

%post -n libradosstriper1
/sbin/ldconfig

%postun -n libradosstriper1
/sbin/ldconfig

#################################################################################
%files -n libradosstriper1-devel
%defattr(-,root,root,-)
%dir %{_includedir}/radosstriper
%{_includedir}/radosstriper/libradosstriper.h
%{_includedir}/radosstriper/libradosstriper.hpp
%{_libdir}/libradosstriper.so

#################################################################################
%files -n librbd1
%defattr(-,root,root,-)
%{_libdir}/librbd.so.*
%if 0%{?_with_lttng}
%{_libdir}/librbd_tp.so.*
%endif


%post -n librbd1
/sbin/ldconfig

%postun -n librbd1
/sbin/ldconfig

#################################################################################
%files -n librbd1-devel
%defattr(-,root,root,-)
%dir %{_includedir}/rbd
%{_includedir}/rbd/librbd.h
%{_includedir}/rbd/librbd.hpp
%{_includedir}/rbd/features.h
%{_libdir}/librbd.so
%if 0%{?_with_lttng}
%{_libdir}/librbd_tp.so
%endif


#################################################################################
%files -n python-rados
%defattr(-,root,root,-)
%{python_sitelib}/rados.py*

#################################################################################
%files -n python-rbd
%defattr(-,root,root,-)
%{python_sitelib}/rbd.py*


#################################################################################
%files radosgw
%defattr(-,root,root,-)
%{_initrddir}/ceph-radosgw
%{_bindir}/radosgw
%{_bindir}/radosgw-admin
%{_mandir}/man8/radosgw.8*
%{_mandir}/man8/radosgw-admin.8*
%{_sbindir}/rcceph-radosgw
%config(noreplace) %{_sysconfdir}/logrotate.d/radosgw
%config %{_sysconfdir}/bash_completion.d/radosgw-admin
%dir %{_localstatedir}/log/radosgw/

%post radosgw
/sbin/ldconfig

%postun radosgw
/sbin/ldconfig
# Package removal cleanup
if [ "$1" -eq "0" ] ; then
    rm -rf /var/log/radosgw
fi

#################################################################################
%files -n ceph-test
%defattr(-,root,root,-)
%{_bindir}/ceph_bench_log
%{_bindir}/ceph_kvstorebench
%{_bindir}/ceph_multi_stress_watch
%{_bindir}/ceph_erasure_code
%{_bindir}/ceph_erasure_code_benchmark
%{_bindir}/ceph_omapbench
%{_bindir}/ceph_perf_objectstore
%{_bindir}/ceph_psim
%{_bindir}/ceph_radosacl
%{_bindir}/ceph_rgw_jsonparser
%{_bindir}/ceph_rgw_multiparser
%{_bindir}/ceph_scratchtool
%{_bindir}/ceph_scratchtoolpp
%{_bindir}/ceph_smalliobench
%{_bindir}/ceph_smalliobenchdumb
%{_bindir}/ceph_smalliobenchfs
%{_bindir}/ceph_smalliobenchrbd
%{_bindir}/ceph_streamtest
%{_bindir}/ceph_test_*
%{_bindir}/ceph_tpbench
%{_bindir}/ceph_xattr_bench
%{_bindir}/ceph-monstore-tool
%{_bindir}/ceph-osdomap-tool
%{_bindir}/ceph-kvstore-tool

#################################################################################
%files selinux
%defattr(-,root,root,-)
%attr(0600,root,root) %{_datadir}/selinux/packages/ceph.pp
%{_datadir}/selinux/devel/include/contrib/ceph.if
%{_mandir}/man8/ceph_selinux.8*

%post selinux
# backup file_contexts before update
. /etc/selinux/config
FILE_CONTEXT=/etc/selinux/${SELINUXTYPE}/contexts/files/file_contexts
cp ${FILE_CONTEXT} ${FILE_CONTEXT}.pre

# Install the policy
/usr/sbin/semodule -i %{_datadir}/selinux/packages/ceph.pp

# Load the policy if SELinux is enabled
if ! /usr/sbin/selinuxenabled; then
    # Do not relabel if selinux is not enabled
    exit 0
fi

if diff ${FILE_CONTEXT} ${FILE_CONTEXT}.pre > /dev/null 2>&1; then
   # Do not relabel if file contexts did not change
   exit 0
fi

# Check whether the daemons are running
/sbin/service ceph status >/dev/null 2>&1
STATUS=$?

# Stop the daemons if they were running
if test $STATUS -eq 0; then
    /sbin/service ceph stop >/dev/null 2>&1
fi

# Now, relabel the files
/usr/sbin/fixfiles -C ${FILE_CONTEXT}.pre restore 2> /dev/null
rm -f ${FILE_CONTEXT}.pre
# The fixfiles command won't fix label for /var/run/ceph
/usr/sbin/restorecon -R /var/run/ceph > /dev/null 2>&1

# Start the daemons iff they were running before
if test $STATUS -eq 0; then
    /sbin/service ceph start >/dev/null 2>&1 || :
fi
exit 0

%postun selinux
if [ $1 -eq 0 ]; then
    # backup file_contexts before update
    . /etc/selinux/config
    FILE_CONTEXT=/etc/selinux/${SELINUXTYPE}/contexts/files/file_contexts
    cp ${FILE_CONTEXT} ${FILE_CONTEXT}.pre

    # Remove the module
    /usr/sbin/semodule -n -r ceph > /dev/null 2>&1

    # Reload the policy if SELinux is enabled
    if ! /usr/sbin/selinuxenabled ; then
        # Do not relabel if SELinux is not enabled
        exit 0
    fi

    # Check whether the daemons are running
    /sbin/service ceph status >/dev/null 2>&1
    STATUS=$?

    # Stop the daemons if they were running
    if test $STATUS -eq 0; then
        /sbin/service ceph stop >/dev/null 2>&1
    fi

    /usr/sbin/fixfiles -C ${FILE_CONTEXT}.pre restore 2> /dev/null
    rm -f ${FILE_CONTEXT}.pre
    # The fixfiles command won't fix label for /var/run/ceph
    /usr/sbin/restorecon -R /var/run/ceph > /dev/null 2>&1

    # Start the daemons if they were running before
    if test $STATUS -eq 0; then
        /sbin/service ceph start >/dev/null 2>&1 || :
    fi
fi
exit 0

%changelog
* Thu Dec 08 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.9-9
- rgw: do not abort when accept a CORS request with short origin (rhbz#1403007)

* Tue Nov 29 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.9-8
- rgw: use hammer rgw_obj_key api (rhbz#1388647)
- Revert "rgw: rgw_obj encoding fixes" (rhbz#1388647)

* Wed Nov 16 2016 Thomas Serlin <tserlin@redhat.com> 1:0.94.9-7
- rgw: handle empty POST condition (rhbz#1389193)

* Wed Oct 26 2016 Thomas Serlin <tserlin@redhat.com> 1:0.94.9-6
- Don't loop forever when reading data from 0 sized segment. (rhbz#1380196)

* Mon Oct 24 2016 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.9-5
- Remove patches for "PG scrub bypasses 'osd_scrub_chunk_max' limit to find
  hash boundary" (rhbz#1373653)

* Mon Oct 10 2016 Thomas Serlin <tserlin@redhat.com> 1:0.94.9-4
- PG: block writes and scan log for scrub using inclusive upper bound (rhbz#1373653)
- osd/PGBackend: specify correct shard for collection_list_range (rhbz#1373653)
- src/osd: relax the requirement that we scrub a whole hash value (rhbz#1373653)
- hobject: clarify is_snap and has_snapset for max (rhbz#1373653)
- rgw_admin: add bi purge command (rhbz#1378995)
- rgw: bucket resharding, adjust logging (rhbz#1378995)
- cls/rgw: bi_list() fix is_truncated returned param (rhbz#1378995)
- rgw_admin: require --yes-i-really-mean-it for bucket reshard (rhbz#1378995)
- rgw_admin: better bucket reshard logging (rhbz#1378995)
- rgw: limit bucket reshard num shards to max possible (rhbz#1378995)
- rgw_admin: fix bi list command (rhbz#1378995)
- rgw_admin: use aio operations for bucket resharding (rhbz#1378995)
- rgw: bucket reshard updates stats (rhbz#1378995)
- cls/rgw: add bucket_update_stats method (rhbz#1378995)
- rgw_admin: reshard also links to new bucket instance (rhbz#1378995)
- rgw: rgw_link_bucket, use correct bucket structure for entry point (rhbz#1378995)
- radosgw-admin: bucket reshard needs --num-shards to be specified (rhbz#1378995)
- cls/rgw: fix bi_list objclass command (rhbz#1378995)
- rgw_admin: bucket rehsrading, initial work (rhbz#1378995)
- rgw: rgw_obj encoding fixes (rhbz#1378995)
- rgw: utilities to support raw bucket index operations (rhbz#1378995)
- rgw: use bucket_info.bucket_id instead of marker where needed (rhbz#1378995)
- cls/rgw: utilities to support raw bucket index operations (rhbz#1378995)
- ceph-objectstore-tool: add a way to split filestore directories offline (rhbz#1367441)

* Tue Sep 20 2016 Thomas Serlin <tserlin@redhat.com> 1:0.94.9-3
- man: add orphan options to radosgw-admin.8 (rhbz#1301706)
- radosgw-admin: add "--orphan-stale-secs" to --help (rhbz#1301706)
- rgw_admin: improve the orphans find help (rhbz#1301706)

* Thu Sep 08 2016 Thomas Serlin <tserlin@redhat.com> 1:0.94.9-2
- rgw: Do not bother to check against conf values during quota handling (rhbz#1347010)
- rgw: Let the default quota settings take effect during user creation (rhbz#1347010)
- 13207: Rados Gateway: Anonymous user is able to read bucket with authenticated read ACL (CVE-2016-7031, rhbz#1372572)

* Wed Aug 31 2016 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.9-1
- Update to 0.94.9 (rhbz#1335269), revert boost-random change

* Fri Aug 26 2016 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.8-1
- Update to 0.94.8 (rhbz#1335269), drop upstreamed patches
- Add rhbz numbers to remaining downstream patches

* Fri Aug 12 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.7-5
- doc: fix by-parttypeuuid in ceph-disk(8) nroff (rhbz#1335564)
- doc: s/by-parttype-uuid/by-parttypeuuid/ in ceph-disk (rhbz#1335564)
- src/test/objectstore/store_test.cc: fix shards for new tests (rhbz#1334534)
- store_test: improve synthetic coverage of the ec stash case (rhbz#1334534)
- store_test: improve synthetic test coverage of long object names (rhbz#1334534)
- TestRados: make half the objects have long names (rhbz#1334534)
- LFNIndex::lfn_translate: consider alt attr as well (rhbz#1334534)
- LFNIndex::created: fix return value with failure injection (rhbz#1334534)
- store_test: add reproducer for #14766 (rhbz#1334534)
- obj_bencher: cosmetic display fixes (rhbz#1332470)
- common: Add space between timestamp and "min lat:" in bench output (rhbz#1332470)
- rados: Add units to rados bench output (rhbz#1332470)
- mon/OSDMonitor: avoid potential expensive grace calculation (rhbz#1331764 rhbz#1333907)
- mon/OSDMonitor: improve reweight_by_utilization() logic (rhbz#1331764 rhbz#1333907)
- [MON] Fixed calculation of %USED. Now it is shows (space used by all replicas)/(raw space available on OSDs). Before it was (size of pool)/(raw space available on OSDs). (rhbz#1330643)
- mon: add a column 'RAW USED' for ceph df detail (rhbz#1330643)
- hammer: rgw: S3: set EncodingType in ListBucketResult (rhbz#1316268)

* Thu Aug 11 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.7-4
- rgw: fix compilation (rhbz#1349484)
- rgw: add bucket_quota to RGWRegionMap::encode_json (rhbz#1349484)
- rgw: remove bucket index objects when deleting the bucket (rhbz#1340496)
- rgw: fix identification of canceled operation (rhbz#1344134)
- rgw: identify racing writes when using copy-if-newer (rhbz#1344134)
- rgw: translate http error 304 to appropriate status (rhbz#1344134)
- rgw: fix if-modified-since boundary (rhbz#1344134)
- rgw: add rgwx-copy-if-newer http header (rhbz#1344134)
- osd: reset session->osdmap if session is not waiting for a map anymore (rhbz#1291632)
- osd: remove all stale osdmaps in handle_osd_map() (rhbz#1291632)
- osd: populate the trim_thru epoch using MOSDMap.oldest_map (rhbz#1291632)
- common: Allow config set with negative value (rhbz#1284696)

* Mon Aug 08 2016 Boris Ranto <branto@redhat.com> - 1:0.94.7-3
- We use SysV init scripts in 1.3, do not sync up the systemd SELinux changes (rhbz#1360444)

* Thu Aug 04 2016 Boris Ranto <branto@redhat.com> - 1:0.94.7-2
- Update SELinux policy/scripts (rhbz#1330279, rhbz#1360444)

* Wed Aug 03 2016 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.7-1
- Update to 0.94.7 (rhbz#1193710, rhbz#1273127, rhbz#1300539, rhbz#1301706,
  rhbz#1305167, rhbz#1306842, rhbz#1312587, rhbz#1316287, rhbz#1322239,
  rhbz#1324497, rhbz#1325322, rhbz#1331523, rhbz#1335269)

* Wed Jul 27 2016 Thomas Serlin <tserlin@redhat.com> 1:0.94.5-15
- WorkQueue: new PointerWQ base class for ContextWQ (rhbz#1358697)
- WorkQueue: add/remove_work_queue methods now thread safe (rhbz#1358697)

* Thu Jun 30 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.5-14
- mon: Monitor: validate prefix on handle_command() (CVE-2016-5009)

* Mon May 23 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.5-13
- rgw: keep track of written_objs correctly (rhbz#1336933)

* Tue Apr 19 2016 Ali Maredia <amaredia@redhat.com> 1:0.94.5-12
- rgw: fix reload on non Debian systems. (rhbz#1314467)
- auth: fix a crash issue due to CryptoHandler::create() failed (rhbz#1327540)
- auth: fix double PK11_DestroyContext() if PK11_DigestFinal() failed (rhbz#1327540) 

* Thu Apr 14 2016 Ali Maredia <amaredia@redhat.com> 1:0.94.5-11
- log: Log.cc: Assign LOG_DEBUG priority to syslog calls (rhbz#1276186)

* Thu Apr 14 2016 Ali Maredia <amaredia@redhat.com> 1:0.94.5-10
- [Backport] reweight-by-utilization (rhbz#1316675)

* Thu Feb 11 2016 Boris Ranto <branto@redhat.com> 1:0.94.5-9
- add /var/log/radosgw to ceph_log_t SELinux type (rhbz#1305981)

* Thu Feb 04 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.5-8
- improve "ceph tell" error message (rhbz#1193710)
- mon: compact full epochs also (rhbz#1287947)
- document "orphans find" radosgw-admin command (rhbz#1301706)
- fix orphans finish segfault (rhbz#1304032)

* Wed Feb 03 2016 Boris Ranto <branto@redhat.com> 1:0.94.5-7
- re-enable lttng support (rhbz#1304455)

* Wed Feb 03 2016 Boris Ranto <branto@redhat.com> 1:0.94.5-6
- do not use lttng by default (rhbz#1304455)
- ceph_context: remove unsafe cast for singletons
- osd: conditionally initialize the tracepoint provider
- librados: conditionally initialize the tracepoint provider
- librbd: conditionally initialize the tracepoint provider
- common: new tracing config options
- tracing: merge tracepoint provider makefiles into main makefile
- tracing: dynamic tracepoint provider helper
- ceph.spec.in: add new tracepoint probe shared libraries
- lttng: move tracepoint probes to dynamic libraries

* Wed Feb 03 2016 Boris Ranto <branto@redhat.com> 1:0.94.5-5
- make ceph-disk restore context of newly mounted OSDs (rhbz#1303799)
- ceph-disk: only call restorecon when available
- Fix selinux context after intitial OSD mount.

* Tue Jan 26 2016 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.5-4
- Set TCMalloc cache size to 128MB and make it configurable (rhbz#1297502)

* Thu Jan 21 2016 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.5-3
- ceph-selinux: drop Requirement on "ceph" package (rhbz#1193228)

* Mon Jan 18 2016 Ken Dreyer <kdreyer@redhat.com> 1:0.94.5-2
- Fix "qemu-kvm crashes with double free or corruption in cephx code"
  (rhbz#1296722)
- disable filestore_xfs_extsize by default (rhbz#1299308)
- Fix "ceph init script requires /lib/lsb/init-functions" (rhbz#1298536)
- Fix "rgw_frontends is unforgiving of whitespace and quotes" (rhbz#1228845)
- Add ceph-monstore-tool inflate-pgmap (rhbz#1263608)
- Fix "ceph sysvinit script calls ceph-disk when it may not be present"
  (rhbz#1225183)
- Fix "'rados' man page doesn't mention the 'listwatchers' switch"
  (rhbz#1293555)
- Fix "osd/PG.cc: 288: FAILED assert(info.last_epoch_started >=
  info.history.last_epoch_started)" (rhbz#1289313)

* Fri Dec 18 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.5-1
- Update to 0.94.5
- Tighten RPM version dependencies (rhbz#1288166)
- Customize "ceph --version" for RHCS
- rgw: implement s3 encoding-type for get bucket (rhbz#1220880)
- Fix "chain_xattr needs to account for xfs 254 byte inline attr limitation"
  (rhbz#1230879)
- Drop dependency on redhat-lsb-core (rhbz#1268971, rhbz#1244158)
- rgw: Add default quota config (rhbz#1259485)
- mon verify that the store is writeable before participating in election
  (rhbz#1262982)
- librbd: resize should only update image size within header (rhbz#1275398)
- librbd: optionally validate RBD pool configuration (snapshot support)
  (rhbz#1276092)
- librbd: fix merge-diff for >2GB diff-files (rhbz#1289390)

* Wed Dec 02 2015 Boris Ranto <branto@redhat.com> 1:0.94.3-4
- Backport SELinux support (rhbz#1159756)

* Wed Nov 04 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.3-3
- Fix "Monitor Crash while creating ecpool" (rhbz#1231630)

* Wed Sep 30 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.3-2
- OSDMap: fill in known encode_features where possible (rhbz#1265973)

* Wed Sep 23 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.3-1
- Update to 0.94.3 (rhbz#1238415)
- Fix RGW attrs handling during COPY operations (rhbz#1253766)

* Mon Sep 14 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-11
- Move rbd-replay* utilities from ceph-test to ceph-common (rhbz#1207362)

* Tue Sep 08 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-10
- rgw : setting max number of buckets for users via ceph.conf option
  (rhbz#1254343)

* Wed Sep 02 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-9
- Fix "RGW returns requested bucket name raw in "Bucket" response header"
  (CVE-2015-5245, rhbz#1258621)
- Fix "rgw: COPYing an old object onto itself produces a truncated object"
  (rhbz#1258618)

* Fri Aug 28 2015 Josh Durgin <jdurgin@redhat.com> 1:0.94.2-8
- Objecter: pg_interval_t::is_new_interval needs pgid from previous pool (rhbz#1255830)

* Wed Aug 19 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-7
- Build with libatomic-ops (rhbz#1254814)

* Thu Aug 13 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-6
- Fix crash with RBD Mandatory Exclusive Lock enabled (rhbz#1249004)
- Fix "Writes beyond 64GB result in an invalidated RBD object map"
  (rhbz#1252084)

* Tue Aug 11 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.2-5
- build with lttng (rhbz#1207362)

* Mon Aug 10 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-4
- rgw: set http status in civetweb (rhbz#1245663)

* Tue Aug 04 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-3
- Fix "OSD crash in release_op_ctx_locks with rgw and pool snaps"
  (rhbz#1223941)
- Fix "RFE: OSD Suicide Timeout should be configurable" (rhbz#1210825)
- Fix "rgw: usage reporting with civetweb doesn't reflect partial download"
  (rhbz#1235845)
- Fix "[MON]: Monitor crash after doing so many crush map edits" (rhbz#1219040)
- Fix "ceph tell: broken error message / wrong hinting" (rhbz#1193710)
- ceph-disk: always check zap is applied on a full device (rhbz#1200182)
- librbd: A client opening an image mid-resize can result in the object map
  being invalidated (rhbz#1224174)
- Fix "PG::find_best_info exclude incomplete for max_last_epoch_started_found"
  (rhbz#1223532)

* Tue Aug 04 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.2-2
- rgw: fix radosgw start-up script (rhbz#1238521)

* Tue Aug 04 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.2-1
- Update to 0.94.2 (rhbz#1238415)

* Tue Jul 28 2015 Ken Dreyer <kdreyer@redhat.com> 1:0.94.1-16
- Log::reopen_log_file: take m_flush_mutex (rhbz#1246694)

* Fri Jun 26 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-15
- Fix "1.3.0: mon fails to come up. dies as soon as started" (rhbz#1222509)

* Thu Jun 18 2015 Yehuda Sadeh <yehuda@redhat.com> - 1:0.94.1-14
- Fix: "rgw deleting S3 objects leaves __shadow_ objects behind" (rhbz#1211431)
- Fix: "rgw: swift api: using x-fresh-metadata=true in object copying using swift API copies custom metadata also" (rhbz#1234644)
- Fix: "rgw: swift API: Providing custom metadata header in COPY operation does not add custom metadata in the new object" (rhbz#1234643)
- Fix: "rgw: COPY doesn't preserve Content-Type if object is larger than 512k" (rhbz#1234635)

* Thu Jun 18 2015 Yehuda Sadeh <yehuda@redhat.com> - 1:0.94.1-13
- Fix "rgw: multipart objects starting with underscore are incompatible with older versions" (rhbz#1232953)

* Fri Jun 12 2015 Jason Dillaman <dillaman@redhat.com> - 1:0.94.1-12
- Fix "librbd: aio calls may block" (rhbz#1225172)

* Wed May 20 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-11
- Fix "cinder-volume keeps opening Ceph clients until the maximum number of
  opened files reached" (rhbz#1219559)
- Fix "rgw: broken manifest when resending part" (rhbz#1222094)
- Fix "rgw: broken multipart upload when resending parts" (rhbz#1222095)
- radosgw init: look in /var/lib/ceph/radosgw (rhbz#1222153)

* Tue May 12 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-10
- Remove ceph-test utilities that link libradosstriper (rhbz#1219322)

* Fri May 08 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-9
- Add ceph-test package (rhbz#1219322)

* Tue May 05 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-8
- Compensate for pg removal bug from firefly and earlier when upgrading to
  hammer (rhbz#1213723)

* Tue Apr 28 2015 Yehuda Sadeh <yehuda@redhat.com> - 1:0.94.1-7
- Fix RGW Swift API header bugs (rhbz#1213989, rhbz#1213986)
- Increase RGW civetweb max threads (rhbz#1214007)
- Fix 'rgw: keystone token cache does not work correctly' (rhbz#1214000)
- Fix 'rgw: object set attrs clobbers object removal bucket index
  update' (rhbz#1214826)
- Fix 'rgw: shouldn't need to disable rgw_socket_path if frontend is
  configured' (rhbz#1214073)
- Fix 'rgw: objects with names starting with underscore become
  inaccessible after upgrading to Hammer' (rhbz#1214103)

* Fri Apr 24 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-6
- Run RGW as root (RHBZ #1214823)

* Fri Apr 17 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-5
- Perform a hardened build (RHBZ #1197734)

* Thu Apr 16 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-4
- Ship ceph-objectstore-tool in ceph-osd sub-package (RHBZ #1211304)

* Thu Apr 16 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-3
- rgw: remove meta file after deleting bucket (RHBZ #1187821)

* Thu Apr 16 2015 Boris Ranto <branto@redhat.com> - 1:0.94.1-2
- Fix dencoder build (RHBZ #1210415)
- Do not build cephfs and mds bits

* Mon Apr 13 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94.1-1
- Rebase to 0.94.1 (RHBZ #1210037)

* Mon Apr 13 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94-2
- Fix socket dir creation on RHEL 7

* Wed Apr 08 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.94-1
- Rebase to 0.94 (RHBZ #1210037)
- Move rbd udev rules to ceph-common (RHBZ #1192022)
- Create socket dir with tmpfiles.d on RHEL 7
- Add libradosstriper1 sub-packages

* Thu Mar 19 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.8-6
- Patch for rgw init socket issue (RHBZ #1203518)

* Fri Feb 13 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.8-5
- Remove ceph-mds (RHBZ #1191791)
- Patch for rgw init ulimit issue (RHBZ #1184588)

* Mon Feb 09 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.8-4
- Build with yasm (RHBZ #1190870)

* Tue Feb 3 2015 Boris Ranto <branto@redhat.com> - 1:0.80.8-3
- Patch build process and repackage ceph-dencoder

* Thu Jan 29 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.8-2
- Remove ceph-dencoder to avoid a gperftools-libs dependency in ceph-common
  (RHBZ #1186953)
- rm extra radosgw logrotate script entry in %%files

* Fri Jan 23 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.8-1
- Rebase to latest upstream version

* Mon Jan 05 2015 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.7-12
- Move ceph-rest-api to ceph-mon subpackage (RHBZ #1176279)

* Mon Dec 22 2014 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.7-11
- Build --with-tcmalloc (gperftools)

* Thu Dec 04 2014 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.7-10
- Move more files into ceph-osd (RHBZ #1170779)
- Use wildcard to capture gzipped man pages for ceph-clsinfo(8) and
  librados-config(8)

* Wed Dec 03 2014 Ken Dreyer <kdreyer@redhat.com> - 1:0.80.7-9
- Update for Ceph Enterprise. Remove ceph-common and other bits that will
  ship in RHEL 7 base.
- Don't require lib packages with the same %%{release}. (The release number
  is not going to match the release number in ceph-common.)
- Split ceph-mon and ceph-osd sub-packages.

* Thu Oct 16 2014 Boris Ranto <branto@redhat.com - 1:0.80.7-1
- Rebase to latest upstream version

* Sat Oct 11 2014 Boris Ranto <branto@redhat.com> - 1:0.80.6-3
- Fix a typo in librados-devel vs librados2-devel dependency

* Fri Oct 10 2014 Boris Ranto <branto@redhat.com> - 1:0.80.6-2
- Provide empty file list for python-ceph-compat and ceph-devel-compat

* Fri Oct 10 2014 Boris Ranto <branto@redhat.com> - 1:0.80.6-1
- Rebase to 0.80.6
- Split ceph-devel and python-ceph packages

* Tue Sep 9 2014 Dan Horák <dan[at]danny.cz> - 1:0.80.5-10
- update Requires for s390(x)

* Wed Sep 3 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-9
- Symlink librd.so.1 to /usr/lib64/qemu only on rhel6+ x86_64 (1136811)

* Thu Aug 21 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-8
- Revert the previous change
- Fix bz 1118504, second attempt (yasm appears to be the package that caused this
- Fix bogus dates

* Wed Aug 20 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-7
- Several more merges from file to try to fix the selinux issue (1118504)

* Sun Aug 17 2014 Kalev Lember <kalevlember@gmail.com> - 1:0.80.5-6
- Obsolete ceph-libcephfs

* Sat Aug 16 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-5
- Do not require xfsprogs/xfsprogs-devel for el6
- Require gperftools-devel for non-ppc*/s390* architectures only
- Do not require junit -- no need to build libcephfs-test.jar
- Build without libxfs for el6
- Build without tcmalloc for ppc*/s390* architectures
- Location of mkcephfs must depend on a rhel release
- Use epoch in the Requires fields [1130700]

* Sat Aug 16 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-4
- Use the proper version name in Obsoletes

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:0.80.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Aug 15 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-2
- Add the arm pthread hack

* Fri Aug 15 2014 Boris Ranto <branto@redhat.com> - 1:0.80.5-1
- Bump the Epoch, we need to keep the latest stable, not development,
  ceph version in fedora
- Use the upstream spec file with the ceph-libs split
- Add libs-compat subpackage [1116546]
- use fedora in rhel 7 checks
- obsolete libcephfs [1116614]
- depend on redhat-lsb-core for the initscript [1108696]

* Wed Aug 13 2014 Kalev Lember <kalevlember@gmail.com> - 0.81.0-6
- Add obsoletes to keep the upgrade path working (#1118510)

* Mon Jul 7 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com> - 0.81.0-5
- revert to old spec until after f21 branch

* Fri Jul 4 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com>
- temporary exclude f21/armv7hl. N.B. it builds fine on f20/armv7hl.

* Fri Jul 4 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com> - 0.81.0-4
- upstream ceph.spec file

* Tue Jul 1 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com> - 0.81.0-3
- upstream ceph.spec file

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.81.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Jun 5 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com>
- el6 ppc64 likewise for tcmalloc, merge from origin/el6

* Thu Jun 5 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com>
- el6 ppc64 does not have gperftools, merge from origin/el6

* Thu Jun 5 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com> - 0.81.0-1
- ceph-0.81.0

* Wed Jun  4 2014 Peter Robinson <pbrobinson@fedoraproject.org> 0.80.1-5
- gperftools now available on aarch64/ppc64

* Fri May 23 2014 Petr Machata <pmachata@redhat.com> - 0.80.1-4
- Rebuild for boost 1.55.0

* Fri May 23 2014 David Tardon <dtardon@redhat.com> - 0.80.1-3
- rebuild for boost 1.55.0

* Wed May 14 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com> - 0.80.1-2
- build epel-6
- exclude %%{_libdir}/ceph/erasure-code in base package

* Tue May 13 2014 Kaleb S. KEITHLEY <kkeithle[at]redhat.com> - 0.80.1-1
- Update to latest stable upstream release, BZ 1095201
- PIE, _hardened_build, BZ 955174

* Thu Feb 06 2014 Ken Dreyer <ken.dreyer@inktank.com> - 0.72.2-2
- Move plugins from -devel into -libs package (#891993). Thanks Michael
  Schwendt.

* Mon Jan 06 2014 Ken Dreyer <ken.dreyer@inktank.com> 0.72.2-1
- Update to latest stable upstream release
- Use HTTPS for URLs
- Submit Automake 1.12 patch upstream
- Move unversioned shared libs from ceph-libs into ceph-devel

* Wed Dec 18 2013 Marcin Juszkiewicz <mjuszkiewicz@redhat.com> 0.67.3-4
- build without tcmalloc on aarch64 (no gperftools)

* Sat Nov 30 2013 Peter Robinson <pbrobinson@fedoraproject.org> 0.67.3-3
- gperftools not currently available on aarch64

* Mon Oct 07 2013 Dan Horák <dan[at]danny.cz> - 0.67.3-2
- fix build on non-x86_64 64-bit arches

* Wed Sep 11 2013 Josef Bacik <josef@toxicpanda.com> - 0.67.3-1
- update to 0.67.3

* Wed Sep 11 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 0.61.7-3
- let base package include all its documentation files via %%doc magic,
  so for Fedora 20 Unversioned Docdirs no files are included accidentally
- include the sample config files again (instead of just an empty docdir
  that has been added for #846735)
- don't include librbd.so.1 also in -devel package (#1003202)
- move one misplaced rados plugin from -devel into -libs package (#891993)
- include missing directories in -devel and -libs packages
- move librados-config into the -devel pkg where its manual page is, too
- add %%_isa to subpackage dependencies
- don't use %%defattr anymore
- add V=1 to make invocation for verbose build output

* Wed Jul 31 2013 Peter Robinson <pbrobinson@fedoraproject.org> 0.61.7-2
- re-enable tmalloc on arm now gperftools is fixed

* Mon Jul 29 2013 Josef Bacik <josef@toxicpanda.com> - 0.61.7-1
- Update to 0.61.7

* Sat Jul 27 2013 pmachata@redhat.com - 0.56.4-2
- Rebuild for boost 1.54.0

* Fri Mar 29 2013 Josef Bacik <josef@toxicpanda.com> - 0.56.4-1
- Update to 0.56.4
- Add upstream d02340d90c9d30d44c962bea7171db3fe3bfba8e to fix logrotate

* Wed Feb 20 2013 Josef Bacik <josef@toxicpanda.com> - 0.56.3-1
- Update to 0.56.3

* Mon Feb 11 2013 Richard W.M. Jones <rjones@redhat.com> - 0.53-2
- Rebuilt to try to fix boost dependency problem in Rawhide.

* Thu Nov  1 2012 Josef Bacik <josef@toxicpanda.com> - 0.53-1
- Update to 0.53

* Mon Sep 24 2012 Jonathan Dieter <jdieter@lesbg.com> - 0.51-3
- Fix automake 1.12 error
- Rebuild after buildroot was messed up

* Tue Sep 18 2012 Jonathan Dieter <jdieter@lesbg.com> - 0.51-2
- Use system leveldb

* Fri Sep 07 2012 David Nalley <david@gnsa.us> - 0.51-1
- Updating to 0.51
- Updated url and source url. 

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.46-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed May  9 2012 Josef Bacik <josef@toxicpanda.com> - 0.46-1
- updated to upstream 0.46
- broke out libcephfs (rhbz# 812975)

* Mon Apr 23 2012 Dan Horák <dan[at]danny.cz> - 0.45-2
- fix detection of C++11 atomic header

* Thu Apr 12 2012 Josef Bacik <josef@toxicpanda.com> - 0.45-1
- updating to upstream 0.45

* Wed Apr  4 2012 Niels de Vos <devos@fedoraproject.org> - 0.44-5
- Add LDFLAGS=-lpthread on any ARM architecture
- Add CFLAGS=-DAO_USE_PTHREAD_DEFS on ARMv5tel

* Mon Mar 26 2012 Dan Horák <dan[at]danny.cz> 0.44-4
- gperftools not available also on ppc

* Mon Mar 26 2012 Jonathan Dieter <jdieter@lesbg.com> - 0.44-3
- Remove unneeded patch

* Sun Mar 25 2012 Jonathan Dieter <jdieter@lesbg.com> - 0.44-2
- Update to 0.44
- Fix build problems

* Mon Mar  5 2012 Jonathan Dieter <jdieter@lesbg.com> - 0.43-1
- Update to 0.43
- Remove upstreamed compile fixes patch
- Remove obsoleted dump_pop patch

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.41-2
- Rebuilt for c++ ABI breakage

* Thu Feb 16 2012 Tom Callaway <spot@fedoraproject.org> 0.41-1
- update to 0.41
- fix issues preventing build
- rebuild against gperftools

* Sat Dec 03 2011 David Nalley <david@gnsa.us> 0.38-1
- updating to upstream 0.39

* Sat Nov 05 2011 David Nalley <david@gnsa.us> 0.37-1
- create /etc/ceph - bug 745462
- upgrading to 0.37, fixing 745460, 691033
- fixing various logrotate bugs 748930, 747101

* Fri Aug 19 2011 Dan Horák <dan[at]danny.cz> 0.31-4
- google-perftools not available also on s390(x)

* Mon Jul 25 2011 Karsten Hopp <karsten@redhat.com> 0.31-3
- build without tcmalloc on ppc64, BR google-perftools is not available there

* Tue Jul 12 2011 Josef Bacik <josef@toxicpanda.com> 0.31-2
- Remove curl/types.h include since we don't use it anymore

* Tue Jul 12 2011 Josef Bacik <josef@toxicpanda.com> 0.31-1
- Update to 0.31

* Tue Apr  5 2011 Josef Bacik <josef@toxicpanda.com> 0.26-2
- Add the compile fix patch

* Tue Apr  5 2011 Josef Bacik <josef@toxicpanda.com> 0.26
- Update to 0.26

* Tue Mar 22 2011 Josef Bacik <josef@toxicpanda.com> 0.25.1-1
- Update to 0.25.1

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.21.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Sep 29 2010 Steven Pritchard <steve@kspei.com> 0.21.3-1
- Update to 0.21.3.

* Mon Aug 30 2010 Steven Pritchard <steve@kspei.com> 0.21.2-1
- Update to 0.21.2.

* Thu Aug 26 2010 Steven Pritchard <steve@kspei.com> 0.21.1-1
- Update to 0.21.1.
- Sample configs moved to /usr/share/doc/ceph/.
- Added cclass, rbd, and cclsinfo.
- Dropped mkmonfs and rbdtool.
- mkcephfs moved to /sbin.
- Add libcls_rbd.so.

* Tue Jul  6 2010 Josef Bacik <josef@toxicpanda.com> 0.20.2-1
- update to 0.20.2

* Wed May  5 2010 Josef Bacik <josef@toxicpanda.com> 0.20-1
- update to 0.20
- disable hadoop building
- remove all the test binaries properly

* Fri Apr 30 2010 Sage Weil <sage@newdream.net> 0.19.1-5
- Remove java deps (no need to build hadoop by default)
- Include all required librados helpers
- Include fetch_config sample
- Include rbdtool
- Remove misc debugging, test binaries

* Fri Apr 30 2010 Josef Bacik <josef@toxicpanda.com> 0.19.1-4
- Add java-devel and java tricks to get hadoop to build

* Mon Apr 26 2010 Josef Bacik <josef@toxicpanda.com> 0.19.1-3
- Move the rados and cauthtool man pages into the base package

* Sun Apr 25 2010 Jonathan Dieter <jdieter@lesbg.com> 0.19.1-2
- Add missing libhadoopcephfs.so* to file list
- Add COPYING to all subpackages
- Fix ownership of /usr/lib[64]/ceph
- Enhance description of fuse client

* Tue Apr 20 2010 Josef Bacik <josef@toxicpanda.com> 0.19.1-1
- Update to 0.19.1

* Mon Feb  8 2010 Josef Bacik <josef@toxicpanda.com> 0.18-1
- Initial spec file creation, based on the template provided in the ceph src
